diff -urpN john-1.7.8-jumbo-6a/src/misc.c john-1.7.8-jumbo-6b/src/misc.c
--- john-1.7.8-jumbo-6a/src/misc.c	2011-08-30 14:57:27.296875000 +0000
+++ john-1.7.8-jumbo-6b/src/misc.c	2011-09-06 18:35:09.000000000 +0000
@@ -157,4 +157,16 @@ char *strlwr(char *s)
 
 	return s;
 }
+char *strupr(char *s)
+{
+	unsigned char *ptr = (unsigned char *)s;
+
+	while (*ptr)
+	if (*ptr >= 'a' && *ptr <= 'z')
+		*ptr++ ^= 0x20;
+	else
+		ptr++;
+
+	return s;
+}
 #endif
diff -urpN john-1.7.8-jumbo-6a/src/misc.h john-1.7.8-jumbo-6b/src/misc.h
--- john-1.7.8-jumbo-6a/src/misc.h	2011-08-30 14:57:27.312500000 +0000
+++ john-1.7.8-jumbo-6b/src/misc.h	2011-09-06 12:56:33.000000000 +0000
@@ -65,8 +65,10 @@ extern char *strnzcat(char *dst, const c
  */
 #ifndef _MSC_VER
 extern char *strlwr(char *s);
+extern char *strupr(char *s);
 #else
 #define strlwr _strlwr
+#define strupr _strupr
 #define strdup _strdup
 #endif
 
diff -urpN john-1.7.8-jumbo-6a/src/pkzip.h john-1.7.8-jumbo-6b/src/pkzip.h
--- john-1.7.8-jumbo-6a/src/pkzip.h	2011-08-30 14:57:27.500000000 +0000
+++ john-1.7.8-jumbo-6b/src/pkzip.h	2011-09-09 20:02:52.000000000 +0000
@@ -46,30 +46,42 @@ static const u32 pkz_crc_32_tab[] =
 
 #define pkzip_crc32(crc,byte) (pkz_crc_32_tab[(u8)((crc)^(byte))] ^ ((crc) >> 8))
 
-#define UBUF_SIZE (32*1024)
-#define MAX_PKZ_FILES 8
+#define MAX_PKZ_FILES 3
+
+#if USE_PKZIP_MAGIC
+typedef struct zip_magic_signatures_t {
+	u8 *magic_signature[8];
+	u8  magic_sig_len[8];
+	u8  magic_count;
+	u8  max_len;
+} ZIP_SIGS;
+#endif
+typedef struct zip_hash_type_t {
+	u8 *h;
+	u16 c;
+	u32 datlen;
+	u8 magic;					// This is used as 'magic' signature type. Also, 255 is 'generic text'
+	u8 full_zip;
+	u32 compType;				// the type of compression  0 or 8
+#if USE_PKZIP_MAGIC
+	ZIP_SIGS *pSig;
+#endif
+} ZIP_HASH;
+
 typedef struct zip_salt_t {
 	u32 cnt;					// number of hashes
 	u32 chk_bytes;				// number of bytes valid in checksum (1 or 2)
-	u32 flags;					// bit mask, that tells us what data is provided in the hash line, and also can tell us what steps to take or not take.
-	u8 h[MAX_PKZ_FILES][12];	// hash data (up to 8)
-	u16 c[MAX_PKZ_FILES];		// the 1 or 2 byte checksums (that match the 1 to 8 hashes)
-	u32 asciilen;				// the length of the asciidat field. This does not tell us how long it decomresses to, but tells us its compressed length.
-	u32 asciiCompType;			// a 0 or 8  (stored or imploded, the only types we handle.).
-	u8 *asciidat;
-	u8 *ascii_decr;
-	u8 *ascii_ucmp;
-	u32 ascii_ucmp_len;
-	u8 *encrDat;				// Encrypted data from the zip file. May be partial, or may be 'full'.  If an ASCII file, then partial will work.
+	ZIP_HASH H[MAX_PKZ_FILES];
 	u32 crc32;					// if a 'full' file of encr data, then this is the CRC
 	u32 compLen;				// length of compressed data (whether part or full)
 	u32 deCompLen;				// length of decompressed data (if full).
 	u32 compType;				// the type of compression  0 or 8
-	long     offset;
-	char *filename;
-	char *ifilename;
-	u8 *full_encr_dat;
-	u8 *full_decr_dat;
+	u32 full_zip_idx;			// the index (0, 1, 2) which contains the 'full zip' data.
+	char *fname;				// if the zip is too large, we open the file in cmp_exact read the
+								// data a small buffer at a time.  If the zip blob is small enough
+								// (under 16k), then it simply read into H[x].h at init() time.
+								// and cmp_exact does not need fname to be used.
+	u32 offset;					// this is the offset to zip data (if we have to read from the file).
 } PKZ_SALT;
 
 typedef union MY_WORD {
